#include <stdlib.h>

#include <qapp.h>
#include <qdialog.h>
#include <qpushbt.h>
#include <qlabel.h>
#include <qmsgbox.h>

#include "maindlg.h"
#include "maindlg.moc"

#include "qprogres.h"

int getRand(int nLower, int nUpper);

CMainDlg::CMainDlg(QWidget *parent, const char *name)
       :QDialog(parent,name)
{
   setCaption("Tim's QProgressCtrl Demonstration");
   // there's a reason I have 2*everything in here
   setFixedSize(2*285,2*152);

   // buttons
   QPushButton *pb;

   pb = new QPushButton("Quit",this);
   pb->setGeometry(2*195,2*130,2*50,2*14);
   connect(pb, SIGNAL(clicked()), SLOT(quitapp()));

   pb = new QPushButton("Step All",this);
   pb->setGeometry(2*140,2*130,2*50,2*14);
   connect(pb,SIGNAL(clicked()),SLOT(stepAll()));

   pb = new QPushButton("Set Random",this);
   pb->setGeometry(2*85,2*130,2*50,2*14);
   connect(pb,SIGNAL(clicked()),SLOT(setRandom()));

   pb = new QPushButton("About",this);
   pb->setGeometry(2*30,2*130,2*50,2*14);
   connect(pb,SIGNAL(clicked()),SLOT(about()));
   
   // start after the lower range
   m_Prog[0] = new QProgressCtrl(this,blockedBar);
   m_Prog[0]->setGeometry(2*5,2*5,2*240,2*35);
   m_Prog[0]->setRange(0,100);
   m_Prog[0]->setStep(5);
   m_Prog[0]->setPos(10);

   // start before the lower range and see what happens
   m_Prog[1] = new QProgressCtrl(this,solidBar,green);
   m_Prog[1]->setGeometry(2*5,2*45,2*240,2*25);
   m_Prog[1]->setRange(500,1000);
   m_Prog[1]->setStep(20);
   m_Prog[1]->setPos(440);

   // let's try a weird range
   m_Prog[2] = new QProgressCtrl(this,blockedBar,yellow,cyan);
   m_Prog[2]->setGeometry(2*5,2*75,2*240,2*14);
   m_Prog[2]->setRange(-1000,+2000);
   m_Prog[2]->setStep(-350);
   m_Prog[2]->setPos(2150);


   // another funky range
   m_Prog[3] = new QProgressCtrl(this,solidBar,red,magenta);
   m_Prog[3]->setGeometry(2*5,2*95,2*240,2*10);
   m_Prog[3]->setRange(-2000,-1000);
   m_Prog[3]->setStep(-150);
   m_Prog[3]->setPos(-1123);

   // let's try a teeny one only 12 pixels in height, including
   // the frame.  It should use the default step of 10 and range
   // of 0 to 100
   m_Prog[4] = new QProgressCtrl(this,blockedBar);
   m_Prog[4]->setGeometry(2*5,2*110,2*240,2*6);

   // a vertical one solid
   m_Prog[5] = new QProgressCtrl(this,solidBar,darkBlue,darkYellow,vertBar);
   m_Prog[5]->setGeometry(500,2*5,2*10,2*110);
   
   // a vertical one with blocks
   m_Prog[6] = new QProgressCtrl(this,blockedBar,darkBlue,lightGray,vertBar);
   m_Prog[6]->setGeometry(530,2*5,2*10,2*110);
}

void CMainDlg::quitapp()
{
   qApp->quit();
}

void CMainDlg::stepAll()
{
   for (int i=0; i<7; i++)
     m_Prog[i]->stepIt();
}

void CMainDlg::setRandom()
{
   m_Prog[0]->setPos(getRand(0,100));
   m_Prog[1]->setPos(getRand(500,1000));
   m_Prog[2]->setPos(getRand(-1000,2000));
   m_Prog[3]->setPos(getRand(-2000,-1000));
   m_Prog[4]->setPos(getRand(0,100));
   m_Prog[5]->setPos(getRand(0,100));
   m_Prog[6]->setPos(getRand(0,100));
}

void CMainDlg::about()
{
   QMessageBox mb;
   mb.setText("Send comments/suggestions/bugs to\nTim Gilman  <tdgilman@best.com>");
   mb.show();
}

int getRand(int nLower, int nUpper)
{
   return (int)(((float)rand()/(float)RAND_MAX)*(float)(nUpper-nLower))+nLower;
}

